#include <iostream>
#include <vector>
#include <cstdio>
#include <cstring>
using namespace std;

int n, q;

vector<int> g[100020];
int par[100020], col[100020];

int find( int v )
{
	vector<int> a;
	int i;
	while ( par[v] != -1 )
	{
		a.push_back( v );
		v = par[v];
	}
	for ( i = 0; (unsigned)i < a.size(); i++ )
		par[a[i]] = v;
	return v;
}

int main()
{
	int i, j, k, x, s;
	
	memset( par, -1, sizeof( par ) );
	memset( col, -1, sizeof( col ) );
	
	scanf( "%d", &n );
	for ( i = 0; i <= n-1; i++ )
	{
		scanf( "%d", &j );
		if ( j == -1 ) continue;
		k = i;
		g[j].push_back( k );
		g[k].push_back( j );
	}
	
	scanf( "%d", &q );
	for ( i = 1; i <= q; i++ )
	{
		scanf( "%d %d %d", &x, &j, &k );
		if ( x == 1 )
		{
			col[j] = k;
			for ( s = 0; (unsigned)s < g[j].size(); s++ )
			{
				if ( col[g[j][s]] == col[j] )
				{
					par[find(g[j][s])] = find( j );
				}
			}
		}
		else
		{
			if ( find( j ) == find( k ) )
			{
				printf( "YES\n" );
			}
			else printf( "NO\n" );
		}
	}
	return 0;
}
