// <-------TEMPLATE--------->
// Author: suh_ash2008
#include <iostream>
#include <cstdio>
#include <cctype>
#include <string>
#include <cmath>
#include <vector>
#include <algorithm>
#include <stack>
#include <queue>
#include <map>
#include <set>
#include <sstream>
#include <fstream>
#include <ctime>
#include <cassert>
#include <string.h>
using namespace std;
#define GI ({int t;scanf("%d",&t);t;})
#define GL ({LL t;scanf("%lld",&t);t;})
#define GD ({double t;scanf("%lf",&t);t;})
#define FOR(i,a,b) for(int i=a;i<b;i++)
#define REP(i,n) FOR(i,0,n)
#define ROF(i,a,b) for(int i=a;i>b;i--)
#define SET(x,a) memset(x,a,sizeof(x))
#define all(a) a.begin(),a.end()
#define rall(a) a.rbegin(),a.rend()
#define tr(i,a) for( typeof(a.begin()) i=a.begin();i!=a.end();i++)
#define pb push_back
#define sz(a) (int)(a.size())
#define INF (int)1e9
#define EPS (double)1e-9
#define is istringstream
#define os ostringstream
#define lb lower_bound
#define ub upper_bound
#define bs binary_search
typedef unsigned long long ULL;
typedef long long LL;
typedef set <int> si;
typedef pair< int,int > ii;
typedef pair< int, ii > pi;
typedef vector< ii > vii;
typedef vector < vii > vvii;
typedef vector< int > vi;
typedef vector< vi > vvi;
// <----------------------END OF TEMPLATE---------------------->

// <---------------------MAIN CODE STARTS HERE--------------------->

#define MAXN 100000+5

int n,q;
int par[MAXN];
int color[MAXN];

vvi G;

inline int find_set(int x){
	if(x==par[x])	return x;
	return par[x]=find_set(par[x]);
}

inline void union_set(int x,int y){
	x=find_set(x),y=find_set(y);
	par[x]=y;
}

int main(){
	int u,v;
		n=GI;
		assert( n>=1 && n<=100000 );
		G.resize(n);
		REP(i,n){
			u=i;v=GI; if ( v == -1 ) continue; G[u].pb(v);G[v].pb(u);
			assert( u>=0 && u<n && v>=0 && v<n);
		}
		REP(i,n)	par[i]=i,color[i]=-1;
		q=GI;
		assert( q>=1 && q<=200000 );
		int a,b;
		REP(i,q){
			v=GI,a=GI,b=GI;
			if(v==1){
				color[a]=b;
				assert( a>=0 && a<n && b>0 && b<=30 );
				tr(j,G[a])	if(color[*j]==b)	union_set(a,*j);
			}
			else{
				assert( a>=0 && a<n && b>=0 && b<n );
				if(find_set(a)==find_set(b))	printf("YES\n");
				else printf("NO\n");
			}
		}
		G.clear();
	return 0;
}
